indexing

   title:       "Abstract commercial formatter class";
   cluster:     "format/commerce [format/commerce]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "abs_com.e"

deferred class ABSTRACT_COMMERCIAL_FORMATTER

inherit
   ABSTRACT_FORMATTER
      undefine make
      redefine output, raise_exception
      end
feature

   picture : STRING

   set_picture (p : STRING) is
      do
         !!picture.make(0)
         x_append(picture,p)
      end

   set_blank_when_zero is
      do
         raise_exception("Illegal command")
      end

   set_justified_right is
      do
         raise_exception("Illegal command")
      end

   set_justified_left is
      do
         raise_exception("Illegal command")
      end

   set_upper_character is
      do
         raise_exception("Illegal command")
      end

   set_lower_character is
      do
         raise_exception("Illegal command")
      end

   set_sign_leading is
      do
         raise_exception("Illegal command")
      end

   set_sign_trailing is
      do
         raise_exception("Illegal command")
      end

   set_sign_leading_separate is
      do
         raise_exception("Illegal command")
      end

   set_sign_trailing_separate is
      do
         raise_exception("Illegal command")
      end

   set_currency(s : STRING) is
   require
      one_char_currency_sign : s.count = 1
      do
      end

   set_point(c : CHARACTER) is
      do
      end

   set_delimiters(s : STRING) is
      do
      end

   output : STRING is
      deferred
      end

feature {ABSTRACT_COMMERCIAL_FORMATTER}

   raise_exception( msg : STRING) is
      local
         s : STRING
      do
         s := "Bad Picture("
         x_append(s,msg)
         x_extend(s,')')
         exc.raise("COMMERCIAL_FORMATTER",s,0,Current)
      end

end -- class ABSTRACT_COMMERCIAL_FORMATTER
