-- This example illustrates how to extend set of printf escape
-- codes available in standard SCIENTIFIC_FORMAT.
--
-- Here  we add  !v  typechar that print  a  vector of  reals.
-- Format specificators  such as width, precision or alignment
-- applied to every element of vector.
--
-- 1).  To  do this, you should create  class  inherited  from
-- ABSTRACT_FORMATTER and redefine callback methods - that set
-- width, precision, etc for you object (See vect_fmt.e)
--
-- 2) Next   you   should   create   class   inherited    from
-- SCIENTIFIC_FORMAT   and   redefine   only  one  methods   -
-- formatters, that  create  table  of  available  for  printf
-- typechars. Add you  own typechar class to defaut table (See
-- ext_form.e).
--
-- That's all!   In this class we demonstrate how it works.

indexing

   title:       "EXT_SCIENTIFIC_FORMAT usage example";
   cluster:     "format/science/examples/vector [format/science/examples/vector]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Andy Malakov  (andy@eiffel.ru) and";
   original:    08,Sep,1995;
   version:     1.0;
   last_change:
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "vector.e"

class VECTOR
      -- Class illustrate SCIENTIFIC_FORMAT usage.

   inherit
      EXT_SCIENTIFIC_FORMAT
         rename make as sformat_make
         end

   creation
      make

   feature

      make is
         local
            vect : ARRAY [ REAL ]
            i : INTEGER
         do
            sformat_make
            !!vect.make(1,5)
            from i := 1 until i > vect.count loop
               vect.put(i+i/9.0,i)
               i:=i+1
            end

            printf ( "Vector !3.2v, with length !d%N", <<vect, vect.count>> )
            set_default_format ( "! 7.5v" )
            print ( vect )

         end -- make

end -- class VECTOR

