indexing

   title:       "Signed integer number formatter";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    08,Sep,1995;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "int_fmt.e"

class INTEGER_FORMATTER

inherit
   UNSIGNED_DECIMAL_INTEGER_FORMATTER
      redefine
         make, set_sign, output
      end
   EXTENDED_MATH

creation
    make

feature

   sign  : STRING

------------------------------------------------------------make
   make, frozen int_make( i : INTEGER_REF) is
   require else
      format_number : i /= Void
   do
      unsigned_decimal_make(int_abs(i.item))
      if i.item < 0 then -- .item added for Symantec C++ bug-around
         sign := "-"
      else
         sign := ""
      end
   end
------------------------------------------------------------set_sign
    set_sign(s:CHARACTER) is
    require else
        legal_sign : (s.is_equal(' ')) or else (s.is_equal('+'))
    do
        -- don't redefine sign if it is "-" or "+" (C) POSIX
        if not sign.is_equal("-") and then not sign.is_equal("+") then
            sign := ""
            x_extend(sign,s)
        end
    end

------------------------------------------------------------output
   output:STRING is
   local
      str  : STRING
   do
      if prec /= -1 then    -- precision was set; POSIX rulez
         set_align_char(' ')
      end
      str := get_plain_number_image(int_abs(inum))
      if (prec=0) and then (inum=0) then
         Result := ""
      else
         str := left_pad(str,'0',prec)
         inspect alignment
         when align_left then
            x_prepend ( str, sign )
            Result := right_pad(str,align_char,width);
         when align_right then
            if align_char = '0' then
               str := left_pad(str,align_char,width-sign.count)
               x_prepend ( str, sign )
               Result := str
            else -- align right with ' '
               x_prepend ( str, sign )
               Result := left_pad(str,align_char,width)
            end
         when align_center then
            x_prepend ( str, sign )
            Result := center_pad ( str, ' ', width )
         end
      end
    end

end -- class INTEGER_FORMATTER
